]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: set variables using `let' instead of `setq' in Emacs tests
[notmuch] / test / test-lib.sh
1 #!/usr/bin/env bash
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # if --tee was passed, write the output not only to the terminal, but
27 # additionally to the file test-results/$BASENAME.out, too.
28 case "$GIT_TEST_TEE_STARTED, $* " in
29 done,*)
30         # do not redirect again
31         ;;
32 *' --tee '*|*' --va'*)
33         mkdir -p test-results
34         BASE=test-results/$(basename "$0" .sh)
35         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
36          echo $? > $BASE.exit) | tee $BASE.out
37         test "$(cat $BASE.exit)" = 0
38         exit
39         ;;
40 esac
41
42 # Keep the original TERM for say_color
43 ORIGINAL_TERM=$TERM
44
45 # For repeatability, reset the environment to known value.
46 LANG=C
47 LC_ALL=C
48 PAGER=cat
49 TZ=UTC
50 TERM=dumb
51 export LANG LC_ALL PAGER TERM TZ
52 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
53
54 # Protect ourselves from common misconfiguration to export
55 # CDPATH into the environment
56 unset CDPATH
57
58 unset GREP_OPTIONS
59
60 # Convenience
61 #
62 # A regexp to match 5 and 40 hexdigits
63 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
64 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
65
66 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
67 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
68
69 # Each test should start with something like this, after copyright notices:
70 #
71 # test_description='Description of this test...
72 # This test checks if command xyzzy does the right thing...
73 # '
74 # . ./test-lib.sh
75 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
76                 TERM=$ORIGINAL_TERM &&
77                 export TERM &&
78                 [ -t 1 ] &&
79                 tput bold >/dev/null 2>&1 &&
80                 tput setaf 1 >/dev/null 2>&1 &&
81                 tput sgr0 >/dev/null 2>&1
82         ) &&
83         color=t
84
85 while test "$#" -ne 0
86 do
87         case "$1" in
88         -d|--d|--de|--deb|--debu|--debug)
89                 debug=t; shift ;;
90         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
91                 immediate=t; shift ;;
92         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
93                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
94         -h|--h|--he|--hel|--help)
95                 help=t; shift ;;
96         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
97                 verbose=t; shift ;;
98         -q|--q|--qu|--qui|--quie|--quiet)
99                 quiet=t; shift ;;
100         --with-dashes)
101                 with_dashes=t; shift ;;
102         --no-color)
103                 color=; shift ;;
104         --no-python)
105                 # noop now...
106                 shift ;;
107         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
108                 valgrind=t; verbose=t; shift ;;
109         --tee)
110                 shift ;; # was handled already
111         --root=*)
112                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
113                 shift ;;
114         *)
115                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
116         esac
117 done
118
119 if test -n "$color"; then
120         say_color () {
121                 (
122                 TERM=$ORIGINAL_TERM
123                 export TERM
124                 case "$1" in
125                         error) tput bold; tput setaf 1;; # bold red
126                         skip)  tput bold; tput setaf 2;; # bold green
127                         pass)  tput setaf 2;;            # green
128                         info)  tput setaf 3;;            # brown
129                         *) test -n "$quiet" && return;;
130                 esac
131                 shift
132                 printf " "
133                 printf "$@"
134                 tput sgr0
135                 )
136         }
137 else
138         say_color() {
139                 test -z "$1" && test -n "$quiet" && return
140                 shift
141                 printf " "
142                 printf "$@"
143         }
144 fi
145
146 error () {
147         say_color error "error: $*\n"
148         GIT_EXIT_OK=t
149         exit 1
150 }
151
152 say () {
153         say_color info "$*"
154 }
155
156 test "${test_description}" != "" ||
157 error "Test script did not set test_description."
158
159 if test "$help" = "t"
160 then
161         echo "Tests ${test_description}"
162         exit 0
163 fi
164
165 echo $(basename "$0"): "Testing ${test_description}"
166
167 exec 5>&1
168
169 test_failure=0
170 test_count=0
171 test_fixed=0
172 test_broken=0
173 test_success=0
174
175 die () {
176         code=$?
177         if test -n "$GIT_EXIT_OK"
178         then
179                 exit $code
180         else
181                 echo >&5 "FATAL: Unexpected exit with code $code"
182                 exit 1
183         fi
184 }
185
186 GIT_EXIT_OK=
187 trap 'die' EXIT
188
189 test_decode_color () {
190         sed     -e 's/.\[1m/<WHITE>/g' \
191                 -e 's/.\[31m/<RED>/g' \
192                 -e 's/.\[32m/<GREEN>/g' \
193                 -e 's/.\[33m/<YELLOW>/g' \
194                 -e 's/.\[34m/<BLUE>/g' \
195                 -e 's/.\[35m/<MAGENTA>/g' \
196                 -e 's/.\[36m/<CYAN>/g' \
197                 -e 's/.\[m/<RESET>/g'
198 }
199
200 q_to_nul () {
201         perl -pe 'y/Q/\000/'
202 }
203
204 q_to_cr () {
205         tr Q '\015'
206 }
207
208 append_cr () {
209         sed -e 's/$/Q/' | tr Q '\015'
210 }
211
212 remove_cr () {
213         tr '\015' Q | sed -e 's/Q$//'
214 }
215
216 # Notmuch helper functions
217 increment_mtime_amount=0
218 increment_mtime ()
219 {
220     dir="$1"
221
222     increment_mtime_amount=$((increment_mtime_amount + 1))
223     touch -d "+${increment_mtime_amount} seconds" "$dir"
224 }
225
226 # Generate a new message in the mail directory, with a unique message
227 # ID and subject. The message is not added to the index.
228 #
229 # After this function returns, the filename of the generated message
230 # is available as $gen_msg_filename and the message ID is available as
231 # $gen_msg_id .
232 #
233 # This function supports named parameters with the bash syntax for
234 # assigning a value to an associative array ([name]=value). The
235 # supported parameters are:
236 #
237 #  [dir]=directory/of/choice
238 #
239 #       Generate the message in directory 'directory/of/choice' within
240 #       the mail store. The directory will be created if necessary.
241 #
242 #  [filename]=name
243 #
244 #       Store the message in file 'name'. The default is to store it
245 #       in 'msg-<count>', where <count> is three-digit number of the
246 #       message.
247 #       
248 #  [body]=text
249 #
250 #       Text to use as the body of the email message
251 #
252 #  '[from]="Some User <user@example.com>"'
253 #  '[to]="Some User <user@example.com>"'
254 #  '[subject]="Subject of email message"'
255 #  '[date]="RFC 822 Date"'
256 #
257 #       Values for email headers. If not provided, default values will
258 #       be generated instead.
259 #
260 #  '[cc]="Some User <user@example.com>"'
261 #  [reply-to]=some-address
262 #  [in-reply-to]=<message-id>
263 #  [references]=<message-id>
264 #  [content-type]=content-type-specification
265 #  '[header]=full header line, including keyword'
266 #
267 #       Additional values for email headers. If these are not provided
268 #       then the relevant headers will simply not appear in the
269 #       message.
270 #
271 #  '[id]=message-id'
272 #
273 #       Controls the message-id of the created message.
274 gen_msg_cnt=0
275 gen_msg_filename=""
276 gen_msg_id=""
277 generate_message ()
278 {
279     # This is our (bash-specific) magic for doing named parameters
280     local -A template="($@)"
281     local additional_headers
282
283     gen_msg_cnt=$((gen_msg_cnt + 1))
284     if [ -z "${template[filename]}" ]; then
285         gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
286     else
287         gen_msg_name=${template[filename]}
288     fi
289
290     if [ -z "${template[id]}" ]; then
291         gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
292     else
293         gen_msg_id="${template[id]}"
294     fi
295
296     if [ -z "${template[dir]}" ]; then
297         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
298     else
299         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
300         mkdir -p "$(dirname "$gen_msg_filename")"
301     fi
302
303     if [ -z "${template[body]}" ]; then
304         template[body]="This is just a test message (#${gen_msg_cnt})"
305     fi
306
307     if [ -z "${template[from]}" ]; then
308         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
309     fi
310
311     if [ -z "${template[to]}" ]; then
312         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
313     fi
314
315     if [ -z "${template[subject]}" ]; then
316         template[subject]="Test message #${gen_msg_cnt}"
317     fi
318
319     if [ -z "${template[date]}" ]; then
320         template[date]="Tue, 05 Jan 2001 15:43:57 -0000"
321     fi
322
323     additional_headers=""
324     if [ ! -z "${template[header]}" ]; then
325         additional_headers="${template[header]}
326 ${additional_headers}"
327     fi
328
329     if [ ! -z "${template[reply-to]}" ]; then
330         additional_headers="Reply-To: ${template[reply-to]}
331 ${additional_headers}"
332     fi
333
334     if [ ! -z "${template[in-reply-to]}" ]; then
335         additional_headers="In-Reply-To: ${template[in-reply-to]}
336 ${additional_headers}"
337     fi
338
339     if [ ! -z "${template[cc]}" ]; then
340         additional_headers="Cc: ${template[cc]}
341 ${additional_headers}"
342     fi
343
344     if [ ! -z "${template[references]}" ]; then
345         additional_headers="References: ${template[references]}
346 ${additional_headers}"
347     fi
348
349     if [ ! -z "${template[content-type]}" ]; then
350         additional_headers="Content-Type: ${template[content-type]}
351 ${additional_headers}"
352     fi
353
354     # Note that in the way we're setting it above and using it below,
355     # `additional_headers' will also serve as the header / body separator
356     # (empty line in between).
357
358     cat <<EOF >"$gen_msg_filename"
359 From: ${template[from]}
360 To: ${template[to]}
361 Message-Id: <${gen_msg_id}>
362 Subject: ${template[subject]}
363 Date: ${template[date]}
364 ${additional_headers}
365 ${template[body]}
366 EOF
367
368     # Ensure that the mtime of the containing directory is updated
369     increment_mtime "$(dirname "${gen_msg_filename}")"
370 }
371
372 # Generate a new message and add it to the database.
373 #
374 # All of the arguments and return values supported by generate_message
375 # are also supported here, so see that function for details.
376 add_message ()
377 {
378     generate_message "$@" &&
379     notmuch new > /dev/null
380 }
381
382 # Deliver a message with emacs and add it to the database
383 #
384 # Uses emacs to generate and deliver a message to the mail store.
385 # Accepts arbitrary extra emacs/elisp functions to modify the message
386 # before sending, which is useful to doing things like attaching files
387 # to the message and encrypting/signing.
388 emacs_deliver_message ()
389 {
390     local subject="$1"
391     local body="$2"
392     shift 2
393     # before we can send a message, we have to prepare the FCC maildir
394     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
395     ../smtp-dummy sent_message &
396     smtp_dummy_pid=$!
397     test_emacs \
398         "(let ((message-send-mail-function 'message-smtpmail-send-it)
399                (smtpmail-smtp-server \"localhost\")
400                (smtpmail-smtp-service \"25025\"))
401            (notmuch-hello)
402            (notmuch-mua-mail)
403            (message-goto-to)
404            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
405            (message-goto-subject)
406            (insert \"${subject}\")
407            (message-goto-body)
408            (insert \"${body}\")
409            $@
410            (message-send-and-exit))" >/dev/null 2>&1
411     wait ${smtp_dummy_pid}
412     notmuch new >/dev/null
413 }
414
415 # Generate a corpus of email and add it to the database.
416 #
417 # This corpus is fixed, (it happens to be 50 messages from early in
418 # the history of the notmuch mailing list), which allows for reliably
419 # testing commands that need to operate on a not-totally-trivial
420 # number of messages.
421 add_email_corpus ()
422 {
423     rm -rf ${MAIL_DIR}
424     if [ -d ../corpus.mail ]; then
425         cp -a ../corpus.mail ${MAIL_DIR}
426     else
427         cp -a ../corpus ${MAIL_DIR}
428         notmuch new >/dev/null
429         cp -a ${MAIL_DIR} ../corpus.mail
430     fi
431 }
432
433 test_begin_subtest ()
434 {
435     if [ -n "$inside_subtest" ]; then
436         exec 1>&6 2>&7          # Restore stdout and stderr
437         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
438     fi
439     test_subtest_name="$1"
440     # Remember stdout and stderr file descriptors and redirect test
441     # output to the previously prepared file descriptors 3 and 4 (see
442     # below)
443     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
444     exec 6>&1 7>&2 >&3 2>&4
445     inside_subtest=t
446 }
447
448 # Pass test if two arguments match
449 #
450 # Note: Unlike all other test_expect_* functions, this function does
451 # not accept a test name. Instead, the caller should call
452 # test_begin_subtest before calling this function in order to set the
453 # name.
454 test_expect_equal ()
455 {
456         exec 1>&6 2>&7          # Restore stdout and stderr
457         inside_subtest=
458         test "$#" = 3 && { prereq=$1; shift; } || prereq=
459         test "$#" = 2 ||
460         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
461
462         output="$1"
463         expected="$2"
464         if ! test_skip "$@"
465         then
466                 if [ "$output" = "$expected" ]; then
467                         test_ok_ "$test_subtest_name"
468                 else
469                         testname=$this_test.$test_count
470                         echo "$expected" > $testname.expected
471                         echo "$output" > $testname.output
472                         test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
473                 fi
474     fi
475 }
476
477 test_expect_equal_file ()
478 {
479         exec 1>&6 2>&7          # Restore stdout and stderr
480         inside_subtest=
481         test "$#" = 3 && { prereq=$1; shift; } || prereq=
482         test "$#" = 2 ||
483         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
484
485         output="$1"
486         expected="$2"
487         if ! test_skip "$@"
488         then
489                 if diff -q "$expected" "$output" >/dev/null ; then
490                         test_ok_ "$test_subtest_name"
491                 else
492                         testname=$this_test.$test_count
493                         cp "$output" $testname.output
494                         cp "$expected" $testname.expected
495                         test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
496                 fi
497     fi
498 }
499
500 test_expect_equal_failure ()
501 {
502         exec 1>&6 2>&7          # Restore stdout and stderr
503         inside_subtest=
504         test "$#" = 3 && { prereq=$1; shift; } || prereq=
505         test "$#" = 2 ||
506         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
507
508         output="$1"
509         expected="$2"
510         if ! test_skip "$@"
511         then
512                 if [ "$output" = "$expected" ]; then
513                         test_known_broken_ok_ "$test_subtest_name"
514                 else
515                         test_known_broken_failure_ "$test_subtest_name"
516                         testname=$this_test.$test_count
517                         echo "$expected" > $testname.expected
518                         echo "$output" > $testname.output
519                 fi
520     fi
521 }
522
523 NOTMUCH_NEW ()
524 {
525     notmuch new | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
526 }
527
528 notmuch_search_sanitize ()
529 {
530     sed -r -e 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
531 }
532
533 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
534 notmuch_show_sanitize ()
535 {
536     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
537 }
538 notmuch_show_sanitize_all ()
539 {
540     sed \
541         -e 's| filename:.*| filename:XXXXX|' \
542         -e 's| id:[^ ]* | id:XXXXX |'
543 }
544
545 notmuch_json_show_sanitize ()
546 {
547     sed -e 's|, |,\n |g' | \
548         sed \
549         -e 's|"id": "[^"]*",|"id": "XXXXX",|' \
550         -e 's|"filename": "[^"]*",|"filename": "YYYYY",|'
551 }
552
553 # End of notmuch helper functions
554
555 # Use test_set_prereq to tell that a particular prerequisite is available.
556 # The prerequisite can later be checked for in two ways:
557 #
558 # - Explicitly using test_have_prereq.
559 #
560 # - Implicitly by specifying the prerequisite tag in the calls to
561 #   test_expect_{success,failure,code}.
562 #
563 # The single parameter is the prerequisite tag (a simple word, in all
564 # capital letters by convention).
565
566 test_set_prereq () {
567         satisfied="$satisfied$1 "
568 }
569 satisfied=" "
570
571 test_have_prereq () {
572         case $satisfied in
573         *" $1 "*)
574                 : yes, have it ;;
575         *)
576                 ! : nope ;;
577         esac
578 }
579
580 # You are not expected to call test_ok_ and test_failure_ directly, use
581 # the text_expect_* functions instead.
582
583 test_ok_ () {
584         test_success=$(($test_success + 1))
585         say_color pass "%-6s" "PASS"
586         echo " $@"
587 }
588
589 test_failure_ () {
590         test_failure=$(($test_failure + 1))
591         say_color error "%-6s" "FAIL"
592         echo " $1"
593         shift
594         echo "$@" | sed -e 's/^/        /'
595         if test "$verbose" != "t"; then cat test.output; fi
596         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
597 }
598
599 test_known_broken_ok_ () {
600         test_fixed=$(($test_fixed+1))
601         say_color pass "%-6s" "FIXED"
602         echo " $@"
603 }
604
605 test_known_broken_failure_ () {
606         test_broken=$(($test_broken+1))
607         say_color pass "%-6s" "BROKEN"
608         echo " $@"
609 }
610
611 test_debug () {
612         test "$debug" = "" || eval "$1"
613 }
614
615 test_run_ () {
616         test_cleanup=:
617         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
618         eval >&3 2>&4 "$1"
619         eval_ret=$?
620         eval >&3 2>&4 "$test_cleanup"
621         return 0
622 }
623
624 test_skip () {
625         test_count=$(($test_count+1))
626         to_skip=
627         for skp in $NOTMUCH_SKIP_TESTS
628         do
629                 case $this_test.$test_count in
630                 $skp)
631                         to_skip=t
632                 esac
633         done
634         if test -z "$to_skip" && test -n "$prereq" &&
635            ! test_have_prereq "$prereq"
636         then
637                 to_skip=t
638         fi
639         case "$to_skip" in
640         t)
641                 say_color skip >&3 "skipping test: $@"
642                 say_color skip "%-6s" "SKIP"
643                 echo " $1"
644                 : true
645                 ;;
646         *)
647                 false
648                 ;;
649         esac
650 }
651
652 test_expect_failure () {
653         test "$#" = 3 && { prereq=$1; shift; } || prereq=
654         test "$#" = 2 ||
655         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
656         if ! test_skip "$@"
657         then
658                 test_run_ "$2"
659                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
660                 then
661                         test_known_broken_ok_ "$1"
662                 else
663                         test_known_broken_failure_ "$1"
664                 fi
665         fi
666 }
667
668 test_expect_success () {
669         test "$#" = 3 && { prereq=$1; shift; } || prereq=
670         test "$#" = 2 ||
671         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
672         if ! test_skip "$@"
673         then
674                 test_run_ "$2"
675                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
676                 then
677                         test_ok_ "$1"
678                 else
679                         test_failure_ "$@"
680                 fi
681         fi
682 }
683
684 test_expect_code () {
685         test "$#" = 4 && { prereq=$1; shift; } || prereq=
686         test "$#" = 3 ||
687         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
688         if ! test_skip "$@"
689         then
690                 test_run_ "$3"
691                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
692                 then
693                         test_ok_ "$2"
694                 else
695                         test_failure_ "$@"
696                 fi
697         fi
698 }
699
700 # test_external runs external test scripts that provide continuous
701 # test output about their progress, and succeeds/fails on
702 # zero/non-zero exit code.  It outputs the test output on stdout even
703 # in non-verbose mode, and announces the external script with "* run
704 # <n>: ..." before running it.  When providing relative paths, keep in
705 # mind that all scripts run in "trash directory".
706 # Usage: test_external description command arguments...
707 # Example: test_external 'Perl API' perl ../path/to/test.pl
708 test_external () {
709         test "$#" = 4 && { prereq=$1; shift; } || prereq=
710         test "$#" = 3 ||
711         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
712         descr="$1"
713         shift
714         if ! test_skip "$descr" "$@"
715         then
716                 # Announce the script to reduce confusion about the
717                 # test output that follows.
718                 say_color "" " run $test_count: $descr ($*)"
719                 # Run command; redirect its stderr to &4 as in
720                 # test_run_, but keep its stdout on our stdout even in
721                 # non-verbose mode.
722                 "$@" 2>&4
723                 if [ "$?" = 0 ]
724                 then
725                         test_ok_ "$descr"
726                 else
727                         test_failure_ "$descr" "$@"
728                 fi
729         fi
730 }
731
732 # Like test_external, but in addition tests that the command generated
733 # no output on stderr.
734 test_external_without_stderr () {
735         # The temporary file has no (and must have no) security
736         # implications.
737         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
738         stderr="$tmp/git-external-stderr.$$.tmp"
739         test_external "$@" 4> "$stderr"
740         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
741         descr="no stderr: $1"
742         shift
743         if [ ! -s "$stderr" ]; then
744                 rm "$stderr"
745                 test_ok_ "$descr"
746         else
747                 if [ "$verbose" = t ]; then
748                         output=`echo; echo Stderr is:; cat "$stderr"`
749                 else
750                         output=
751                 fi
752                 # rm first in case test_failure exits.
753                 rm "$stderr"
754                 test_failure_ "$descr" "$@" "$output"
755         fi
756 }
757
758 # This is not among top-level (test_expect_success | test_expect_failure)
759 # but is a prefix that can be used in the test script, like:
760 #
761 #       test_expect_success 'complain and die' '
762 #           do something &&
763 #           do something else &&
764 #           test_must_fail git checkout ../outerspace
765 #       '
766 #
767 # Writing this as "! git checkout ../outerspace" is wrong, because
768 # the failure could be due to a segv.  We want a controlled failure.
769
770 test_must_fail () {
771         "$@"
772         test $? -gt 0 -a $? -le 129 -o $? -gt 192
773 }
774
775 # test_cmp is a helper function to compare actual and expected output.
776 # You can use it like:
777 #
778 #       test_expect_success 'foo works' '
779 #               echo expected >expected &&
780 #               foo >actual &&
781 #               test_cmp expected actual
782 #       '
783 #
784 # This could be written as either "cmp" or "diff -u", but:
785 # - cmp's output is not nearly as easy to read as diff -u
786 # - not all diff versions understand "-u"
787
788 test_cmp() {
789         $GIT_TEST_CMP "$@"
790 }
791
792 # This function can be used to schedule some commands to be run
793 # unconditionally at the end of the test to restore sanity:
794 #
795 #       test_expect_success 'test core.capslock' '
796 #               git config core.capslock true &&
797 #               test_when_finished "git config --unset core.capslock" &&
798 #               hello world
799 #       '
800 #
801 # That would be roughly equivalent to
802 #
803 #       test_expect_success 'test core.capslock' '
804 #               git config core.capslock true &&
805 #               hello world
806 #               git config --unset core.capslock
807 #       '
808 #
809 # except that the greeting and config --unset must both succeed for
810 # the test to pass.
811
812 test_when_finished () {
813         test_cleanup="{ $*
814                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
815 }
816
817 test_done () {
818         GIT_EXIT_OK=t
819         test_results_dir="$TEST_DIRECTORY/test-results"
820         mkdir -p "$test_results_dir"
821         test_results_path="$test_results_dir/${0%.sh}-$$"
822
823         echo "total $test_count" >> $test_results_path
824         echo "success $test_success" >> $test_results_path
825         echo "fixed $test_fixed" >> $test_results_path
826         echo "broken $test_broken" >> $test_results_path
827         echo "failed $test_failure" >> $test_results_path
828         echo "" >> $test_results_path
829
830         echo
831
832         if [ "$test_failure" = "0" ]; then
833             if [ "$test_broken" = "0" ]; then       
834                 rm -rf "$remove_tmp"
835             fi
836             exit 0
837         else
838             exit 1
839         fi
840 }
841
842 test_emacs () {
843         # Construct a little test script here for the benefit of the user,
844         # (who can easily run "run_emacs" to get the same emacs environment
845         # for investigating any failures).    
846         cat <<EOF > run_emacs
847 #!/bin/sh
848 export PATH=$PATH
849 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
850
851 # We assume that the user will give a command-line argument only if
852 # wanting to run in batch mode.
853 if [ \$# -gt 0 ]; then
854         BATCH=--batch
855 fi
856
857 # Here's what we are using here:
858 #
859 # --batch:              Quit after given commands and print all (messages)
860 #
861 # --no-init-file        Don't load users ~/.emacs
862 #
863 # --no-site-file        Don't load the site-wide startup stuff
864 #
865 # --directory           Ensure that the local elisp sources are found
866 #
867 # --load                Force loading of notmuch.el and test-lib.el
868
869 emacs \$BATCH --no-init-file --no-site-file \
870         --directory ../../emacs --load notmuch.el \
871         --directory .. --load test-lib.el \
872         --eval "(progn \$@)"
873 EOF
874         chmod a+x ./run_emacs
875         ./run_emacs "$@"
876 }
877
878
879 find_notmuch_path ()
880 {
881     dir="$1"
882
883     while [ -n "$dir" ]; do
884         bin="$dir/notmuch"
885         if [ -x "$bin" ]; then
886             echo "$dir"
887             return
888         fi
889         dir="$(dirname "$dir")"
890         if [ "$dir" = "/" ]; then
891             break
892         fi
893     done
894 }
895
896 # Test the binaries we have just built.  The tests are kept in
897 # test/ subdirectory and are run in 'trash directory' subdirectory.
898 TEST_DIRECTORY=$(pwd)
899 if test -n "$valgrind"
900 then
901         make_symlink () {
902                 test -h "$2" &&
903                 test "$1" = "$(readlink "$2")" || {
904                         # be super paranoid
905                         if mkdir "$2".lock
906                         then
907                                 rm -f "$2" &&
908                                 ln -s "$1" "$2" &&
909                                 rm -r "$2".lock
910                         else
911                                 while test -d "$2".lock
912                                 do
913                                         say "Waiting for lock on $2."
914                                         sleep 1
915                                 done
916                         fi
917                 }
918         }
919
920         make_valgrind_symlink () {
921                 # handle only executables
922                 test -x "$1" || return
923
924                 base=$(basename "$1")
925                 symlink_target=$TEST_DIRECTORY/../$base
926                 # do not override scripts
927                 if test -x "$symlink_target" &&
928                     test ! -d "$symlink_target" &&
929                     test "#!" != "$(head -c 2 < "$symlink_target")"
930                 then
931                         symlink_target=../valgrind.sh
932                 fi
933                 case "$base" in
934                 *.sh|*.perl)
935                         symlink_target=../unprocessed-script
936                 esac
937                 # create the link, or replace it if it is out of date
938                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
939         }
940
941         # override notmuch executable in TEST_DIRECTORY/..
942         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
943         mkdir -p "$GIT_VALGRIND"/bin
944         make_valgrind_symlink $TEST_DIRECTORY/../notmuch
945         OLDIFS=$IFS
946         IFS=:
947         for path in $PATH
948         do
949                 ls "$path"/notmuch 2> /dev/null |
950                 while read file
951                 do
952                         make_valgrind_symlink "$file"
953                 done
954         done
955         IFS=$OLDIFS
956         PATH=$GIT_VALGRIND/bin:$PATH
957         GIT_EXEC_PATH=$GIT_VALGRIND/bin
958         export GIT_VALGRIND
959 else # normal case
960         notmuch_path=`find_notmuch_path "$TEST_DIRECTORY"`
961         test -n "$notmuch_path" && PATH="$notmuch_path:$PATH"
962 fi
963 export PATH
964
965 # Test repository
966 test="tmp.$(basename "$0" .sh)"
967 test -n "$root" && test="$root/$test"
968 case "$test" in
969 /*) TMP_DIRECTORY="$test" ;;
970  *) TMP_DIRECTORY="$TEST_DIRECTORY/$test" ;;
971 esac
972 test ! -z "$debug" || remove_tmp=$TMP_DIRECTORY
973 rm -fr "$test" || {
974         GIT_EXIT_OK=t
975         echo >&5 "FATAL: Cannot prepare test area"
976         exit 1
977 }
978
979 # A temporary home directory is needed by at least:
980 # - emacs/"Sending a message via (fake) SMTP"
981 # - emacs/"Reply within emacs"
982 # - crypto/emacs_deliver_message
983 export HOME="${TMP_DIRECTORY}/home"
984 mkdir -p "${HOME}"
985
986 MAIL_DIR="${TMP_DIRECTORY}/mail"
987 export GNUPGHOME="${TMP_DIRECTORY}/gnupg"
988 export NOTMUCH_CONFIG="${TMP_DIRECTORY}/notmuch-config"
989
990 mkdir -p "${test}"
991 mkdir -p "${MAIL_DIR}"
992
993 cat <<EOF >"${NOTMUCH_CONFIG}"
994 [database]
995 path=${MAIL_DIR}
996
997 [user]
998 name=Notmuch Test Suite
999 primary_email=test_suite@notmuchmail.org
1000 other_email=test_suite_other@notmuchmail.org;test_suite@otherdomain.org
1001 EOF
1002
1003
1004 # Use -P to resolve symlinks in our working directory so that the cwd
1005 # in subprocesses like git equals our $PWD (for pathname comparisons).
1006 cd -P "$test" || error "Cannot setup test environment"
1007
1008 if test "$verbose" = "t"
1009 then
1010         exec 4>&2 3>&1
1011 else
1012         exec 4>test.output 3>&4
1013 fi
1014
1015 this_test=${0##*/}
1016 for skp in $NOTMUCH_SKIP_TESTS
1017 do
1018         to_skip=
1019         for skp in $NOTMUCH_SKIP_TESTS
1020         do
1021                 case "$this_test" in
1022                 $skp)
1023                         to_skip=t
1024                 esac
1025         done
1026         case "$to_skip" in
1027         t)
1028                 say_color skip >&3 "skipping test $this_test altogether"
1029                 say_color skip "skip all tests in $this_test"
1030                 test_done
1031         esac
1032 done
1033
1034 # Provide an implementation of the 'yes' utility
1035 yes () {
1036         if test $# = 0
1037         then
1038                 y=y
1039         else
1040                 y="$*"
1041         fi
1042
1043         while echo "$y"
1044         do
1045                 :
1046         done
1047 }
1048
1049 # Fix some commands on Windows
1050 case $(uname -s) in
1051 *MINGW*)
1052         # Windows has its own (incompatible) sort and find
1053         sort () {
1054                 /usr/bin/sort "$@"
1055         }
1056         find () {
1057                 /usr/bin/find "$@"
1058         }
1059         sum () {
1060                 md5sum "$@"
1061         }
1062         # git sees Windows-style pwd
1063         pwd () {
1064                 builtin pwd -W
1065         }
1066         # no POSIX permissions
1067         # backslashes in pathspec are converted to '/'
1068         # exec does not inherit the PID
1069         ;;
1070 *)
1071         test_set_prereq POSIXPERM
1072         test_set_prereq BSLASHPSPEC
1073         test_set_prereq EXECKEEPSPID
1074         ;;
1075 esac
1076
1077 test -z "$NO_PERL" && test_set_prereq PERL
1078 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1079
1080 # test whether the filesystem supports symbolic links
1081 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1082 rm -f y